"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.doFindEffectedPackages = void 0;
const getProjectPkgs_1 = __importDefault(require("@thatdevops/core/pkgman/getProjectPkgs"));
function doFindEffectedPackages(changedPkgs) {
    return __awaiter(this, void 0, void 0, function* () {
        const allEffected = [];
        let effected = yield doFindNewEffectedPackages(changedPkgs);
        allEffected.push(...effected);
        while (effected.length) {
            const newEffected = yield doFindNewEffectedPackages(effected);
            effected = newEffected.filter(p => !allEffected.find(p2 => p2.name === p.name));
            allEffected.push(...effected);
        }
        return allEffected;
    });
}
exports.doFindEffectedPackages = doFindEffectedPackages;
exports.default = doFindEffectedPackages;
function doFindNewEffectedPackages(changedPkgs) {
    return __awaiter(this, void 0, void 0, function* () {
        const pkgs = yield (0, getProjectPkgs_1.default)();
        const effected = [];
        for (const changedPkg of changedPkgs) {
            effected.push(changedPkg);
            for (const pkg of pkgs) {
                if (!effected.find(p => p.name === pkg.name)) {
                    for (const depList of ['dependencies', 'devDependencies']) {
                        const deps = pkg.json[depList];
                        for (const depName in deps) {
                            if (depName === changedPkg.name) {
                                effected.push(pkg);
                            }
                        }
                    }
                }
            }
        }
        return effected;
    });
}
//# sourceMappingURL=doFindEffectedPackages.js.map